import { LCDClient } from "@osmonauts/lcd";
export class LCDQueryClient extends LCDClient {
  constructor({
    restEndpoint
  }) {
    super({
      restEndpoint
    });
  }
  /* Params queries params of the distribution module. */


  async params(params) {
    const endpoint = `cosmos/distribution/v1beta1/params`;
    return await this.request(endpoint);
  }
  /* ValidatorOutstandingRewards queries rewards of a validator address. */


  async validatorOutstandingRewards(params) {
    const options = {
      params: {}
    };

    if (typeof (params === null || params === void 0 ? void 0 : params.validatorAddress) !== "undefined") {
      options.params.validator_address = params.validatorAddress;
    }

    const endpoint = `cosmos/distribution/v1beta1/validators/${params.validator_address}/outstanding_rewards`;
    return await this.request(endpoint, options);
  }
  /* ValidatorCommission queries accumulated commission for a validator. */


  async validatorCommission(params) {
    const options = {
      params: {}
    };

    if (typeof (params === null || params === void 0 ? void 0 : params.validatorAddress) !== "undefined") {
      options.params.validator_address = params.validatorAddress;
    }

    const endpoint = `cosmos/distribution/v1beta1/validators/${params.validator_address}/commission`;
    return await this.request(endpoint, options);
  }
  /* ValidatorSlashes queries slash events of a validator. */


  async validatorSlashes(params) {
    const options = {
      params: {}
    };

    if (typeof (params === null || params === void 0 ? void 0 : params.validatorAddress) !== "undefined") {
      options.params.validator_address = params.validatorAddress;
    }

    if (typeof (params === null || params === void 0 ? void 0 : params.startingHeight) !== "undefined") {
      options.params.starting_height = params.startingHeight;
    }

    if (typeof (params === null || params === void 0 ? void 0 : params.endingHeight) !== "undefined") {
      options.params.ending_height = params.endingHeight;
    }

    if (typeof (params === null || params === void 0 ? void 0 : params.pagination) !== "undefined") {
      options.params.pagination = params.pagination;
    }

    const endpoint = `cosmos/distribution/v1beta1/validators/${params.validator_address}/slashes`;
    return await this.request(endpoint, options);
  }
  /* DelegationRewards queries the total rewards accrued by a delegation. */


  async delegationRewards(params) {
    const options = {
      params: {}
    };

    if (typeof (params === null || params === void 0 ? void 0 : params.delegatorAddress) !== "undefined") {
      options.params.delegator_address = params.delegatorAddress;
    }

    if (typeof (params === null || params === void 0 ? void 0 : params.validatorAddress) !== "undefined") {
      options.params.validator_address = params.validatorAddress;
    }

    const endpoint = `cosmos/distribution/v1beta1/delegators/${params.delegator_address}rewards/${params.validator_address}`;
    return await this.request(endpoint, options);
  }
  /* DelegationTotalRewards queries the total rewards accrued by a each
  validator. */


  async delegationTotalRewards(params) {
    const options = {
      params: {}
    };

    if (typeof (params === null || params === void 0 ? void 0 : params.delegatorAddress) !== "undefined") {
      options.params.delegator_address = params.delegatorAddress;
    }

    const endpoint = `cosmos/distribution/v1beta1/delegators/${params.delegator_address}/rewards`;
    return await this.request(endpoint, options);
  }
  /* DelegatorValidators queries the validators of a delegator. */


  async delegatorValidators(params) {
    const options = {
      params: {}
    };

    if (typeof (params === null || params === void 0 ? void 0 : params.delegatorAddress) !== "undefined") {
      options.params.delegator_address = params.delegatorAddress;
    }

    const endpoint = `cosmos/distribution/v1beta1/delegators/${params.delegator_address}/validators`;
    return await this.request(endpoint, options);
  }
  /* DelegatorWithdrawAddress queries withdraw address of a delegator. */


  async delegatorWithdrawAddress(params) {
    const options = {
      params: {}
    };

    if (typeof (params === null || params === void 0 ? void 0 : params.delegatorAddress) !== "undefined") {
      options.params.delegator_address = params.delegatorAddress;
    }

    const endpoint = `cosmos/distribution/v1beta1/delegators/${params.delegator_address}/withdraw_address`;
    return await this.request(endpoint, options);
  }
  /* CommunityPool queries the community pool coins. */


  async communityPool(params) {
    const endpoint = `cosmos/distribution/v1beta1/community_pool`;
    return await this.request(endpoint);
  }

}