import { LCDClient } from "@osmonauts/lcd";
export class LCDQueryClient extends LCDClient {
  constructor({
    restEndpoint
  }) {
    super({
      restEndpoint
    });
  }
  /* Evidence queries evidence based on evidence hash. */


  async evidence(params) {
    const options = {
      params: {}
    };

    if (typeof (params === null || params === void 0 ? void 0 : params.evidenceHash) !== "undefined") {
      options.params.evidence_hash = params.evidenceHash;
    }

    const endpoint = `cosmos/evidence/v1beta1/evidence/${params.evidence_hash}`;
    return await this.request(endpoint, options);
  }
  /* AllEvidence queries all evidence. */


  async allEvidence(params) {
    const options = {
      params: {}
    };

    if (typeof (params === null || params === void 0 ? void 0 : params.pagination) !== "undefined") {
      options.params.pagination = params.pagination;
    }

    const endpoint = `cosmos/evidence/v1beta1/evidence`;
    return await this.request(endpoint, options);
  }

}