import { LCDClient } from "@osmonauts/lcd";
export class LCDQueryClient extends LCDClient {
  constructor({
    restEndpoint
  }) {
    super({
      restEndpoint
    });
  }
  /* Params queries a specific parameter of a module, given its subspace and
  key. */


  async params(params) {
    const options = {
      params: {}
    };

    if (typeof (params === null || params === void 0 ? void 0 : params.subspace) !== "undefined") {
      options.params.subspace = params.subspace;
    }

    if (typeof (params === null || params === void 0 ? void 0 : params.key) !== "undefined") {
      options.params.key = params.key;
    }

    const endpoint = `cosmos/params/v1beta1/params`;
    return await this.request(endpoint, options);
  }
  /* Subspaces queries for all registered subspaces and all keys for a subspace. */


  async subspaces(params) {
    const endpoint = `cosmos/params/v1beta1/subspaces`;
    return await this.request(endpoint);
  }

}