import { LCDClient } from "@osmonauts/lcd";
export class LCDQueryClient extends LCDClient {
  constructor({
    restEndpoint
  }) {
    super({
      restEndpoint
    });
  }
  /* DenomTrace queries a denomination trace information. */


  async denomTrace(params) {
    const endpoint = `ibc/apps/transfer/v1/denom_traces/${params.hash}`;
    return await this.request(endpoint);
  }
  /* DenomTraces queries all denomination traces. */


  async denomTraces(params) {
    const options = {
      params: {}
    };

    if (typeof (params === null || params === void 0 ? void 0 : params.pagination) !== "undefined") {
      options.params.pagination = params.pagination;
    }

    const endpoint = `ibc/apps/transfer/v1/denom_traces`;
    return await this.request(endpoint, options);
  }
  /* Params queries all parameters of the ibc-transfer module. */


  async params(params) {
    const endpoint = `ibc/apps/transfer/v1/params`;
    return await this.request(endpoint);
  }

}